//+------------------------------------------------------------------+
//|                                                  EA_MARTIN_M.mq4 |
//|                                                               TO |
//|                         http://www.forex-tradexperts-to.narod.ru |
//+------------------------------------------------------------------+
#property copyright "TO"
#property link      "http://www.forex-tradexperts-to.narod.ru"

extern int RASS_MINUS = 50;
extern int RASS = 10;
extern double LOT = 0.1;
extern int ID = 3275;

int init()
{
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   int number;
   close_MIN();
   if ( order_total_type(0) == 0 && order_total_type(1) == 0 )
   {
      open (0,check_lot(LOT),0,0);
      open (1,check_lot(LOT),0,0);
   }   
   if ( MathAbs(last_trade(0)-MarketInfo(Symbol(),MODE_ASK))/Point > RASS  )
   {
      close_type_prof(0);   
      if ( order_on_same_price(0) )open (0,check_lot(LOT),0,0);      
   }
   if ( MathAbs(last_trade(1)-MarketInfo(Symbol(),MODE_BID))/Point > RASS  )
   {
      close_type_prof(1);   
      if ( order_on_same_price(1) )open (1,check_lot(LOT),0,0);      
   }
   return(0);
}

void close_MIN()
{
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == ID )
      {         
         if ( OrderProfit()/(OrderLots()*MarketInfo(Symbol(),MODE_TICKVALUE)) <= (-1)*RASS_MINUS )
         {
            close_all();
            break;
         }
      } 
   }
}

void close_all( int type_1 = -1,int type_2 = -1, int bars = 0 )
{
   int i;
   bool flag = false;
   if ( bars != 0 )flag = true;
   for(i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == ID && ((OrderType() == type_1 || OrderType() == type_2) || (type_1 == -1 && type_2 == -1)) && OrderType() < 2 && !flag )close(OrderTicket());
      if(OrderMagicNumber() == ID && ((OrderType() == type_1 || OrderType() == type_2) || (type_1 == -1 && type_2 == -1)) && OrderType() > 1 && !flag )OrderDelete(OrderTicket());      
      if(OrderMagicNumber() == ID && ((OrderType() == type_1 || OrderType() == type_2) || (type_1 == -1 && type_2 == -1)) && OrderType() < 2 && flag && iBarShift(OrderSymbol(),Period(),OrderOpenTime())-bars >= 0 )close(OrderTicket());
      if(OrderMagicNumber() == ID && ((OrderType() == type_1 || OrderType() == type_2) || (type_1 == -1 && type_2 == -1)) && OrderType() > 1 && flag && iBarShift(OrderSymbol(),Period(),OrderOpenTime())-bars >= 0 )OrderDelete(OrderTicket());
   }   
}

bool order_on_same_price ( int type )
{
   int i;
   bool res = true;
   for(i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == ID && OrderType() == type)
      {         
         if ( type == 0 && MathAbs(OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/Point < RASS ){res=false;break;}
         if ( type == 1 && MathAbs(OrderOpenPrice()-MarketInfo(Symbol(),MODE_BID))/Point < RASS ){res=false;break;}
      } 
   }
   return(res);
}

void close_type_prof(int type)
{
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == ID && OrderType() == type && OrderProfit() > 0 )close(OrderTicket());
   }   
}

double last_trade(int type)
{
   int i;
   datetime time=0;
   double prof=0;
   for(i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);      
      if( OrderOpenTime()>time && OrderMagicNumber()==ID && OrderType() == type )
      {
         time=OrderOpenTime();
         prof = OrderOpenPrice();
      }
   }
   return(prof);
}

int order_total_type( int type )
{
   int i;
   int kol=0;
   for(i=OrdersTotal()-1;i>=0;i--)       
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==ID && OrderType() == type)kol++;         
   }
   return(kol);   
}

double check_lot(double &lo)
{
   double l = MarketInfo(Symbol(),MODE_LOTSTEP);
   int ok = 0;
   while ( l < 1 ){l*=10;ok++;}
   if( lo < MarketInfo(Symbol(),MODE_MINLOT) )lo = MarketInfo(Symbol(),MODE_MINLOT);
   if( lo > MarketInfo(Symbol(),MODE_MAXLOT) )lo = MarketInfo(Symbol(),MODE_MAXLOT);
   return(NormalizeDouble(lo,ok));
}

int open(int type, double l, double sl, double tp, string comm = "")
{
   int isOpened = 0;
   int try = 0;   
   while ( IsTradeContextBusy() ){Sleep(500);}    
   RefreshRates();   
   if(type==0)isOpened = OrderSend(Symbol(),type,l,NormalizeDouble(Ask,Digits),100,sl,tp,comm,ID);
   if(type==1)isOpened = OrderSend(Symbol(),type,l,NormalizeDouble(Bid,Digits),100,sl,tp,comm,ID);
   Sleep(500);      
   while(isOpened<0) 
   {
      RefreshRates();
      try++;      
      if(type==0)isOpened = OrderSend(Symbol(),type,l,NormalizeDouble(Ask,Digits),100,sl,tp,comm,ID);
      if(type==1)isOpened = OrderSend(Symbol(),type,l,NormalizeDouble(Bid,Digits),100,sl,tp,comm,ID);
      if(try > 5) break;      
      if(isOpened>=0)break;      
      Sleep(500);
   }   
   if(isOpened<0) Alert("����� �� ������, ������ :", GetLastError());
   return (isOpened);
}

bool close(int ticket)
{
   bool isClosed = false;
   int try = 0;
   isClosed = OrderClose(ticket, OrderLots(),OrderClosePrice(),100, 0);
   while(!isClosed)
   {
      Sleep(1000);
      try++;
      isClosed = OrderClose(ticket, OrderLots(),OrderClosePrice(),100, 0);
      if(try > 5 || isClosed) break;
   }
   if(!isClosed) Print("Order ", ticket, " was NOT closed due to error:", GetLastError());
   return (isClosed);
}